      subroutine writesub(nkmax,amom,c0,d0,c1,d1,c2,d2,c3,d3)
      implicit none
      include 'cparams.f'
      integer nkmax,kk
      double precision amom(nka)
      double precision c0(nka),d0(nka),c1(nka),d1(nka)
      double precision c2(nka),d2(nka),c3(nka),d3(nka)
      open(66,form='formatted',status='unknown',name='results.txt')
      write(66,777)
      write(6,777)
c 777   format('! k(MeV)   C(k)    Cpar(k)   Cin(k)  Cout(k)  Npairs')
777   format('! k(MeV)   C(k)    Cout(k)  Cbeam(k) Cside(k) Npairs')
      do kk=1,nkmax
         if(d0(kk).gt.0.1) c0(kk)=c0(kk)/d0(kk)
         if(d0(kk).le.0.1) c0(kk)=-1.d0
         if(d1(kk).gt.0.1) c1(kk)=c1(kk)/d1(kk)
         if(d1(kk).le.0.1) c1(kk)=-1.d0
         if(d2(kk).gt.0.1) c2(kk)=c2(kk)/d2(kk)
         if(d2(kk).le.0.1) c2(kk)=-1.d0
         if(d3(kk).gt.0.1) c3(kk)=c3(kk)/d3(kk)
         if(d3(kk).le.0.1) c3(kk)=-1.d0
         write(66,123) dfloat(ireduce)*amom(kk),c0(kk),c1(kk),
     +        c2(kk),c3(kk),d0(kk)	
         write(6,123) dfloat(ireduce)*amom(kk),c0(kk),c1(kk),
     +        c2(kk),c3(kk),d0(kk)	
      enddo
 123  format(f6.1,2x,f7.2,2x,f7.2,2x,f7.2,2x,f7.2,5x,f8.1)
      close(66)
      return
      end

      subroutine writesub3d(nkmax,amom,c3d,d3d)
      implicit none
      include 'cparams.f'
      integer nkmax,ix3d,iy3d,iz3d
      double precision amom(nka)
      double precision c3d(nka,nka,nka),d3d(nka,nka,nka)
      open(67,form='formatted',status='unknown',name='results3d.txt')
      write(67,*) nkmax
      do ix3d=1,nkmax
         do iy3d=1,nkmax
            do iz3d=1,nkmax
               if(d3d(ix3d,iy3d,iz3d).gt.0.1) then
                  c3d(ix3d,iy3d,iz3d)
     +                 =c3d(ix3d,iy3d,iz3d)/d3d(ix3d,iy3d,iz3d)
               else
                  c3d(ix3d,iy3d,iz3d)=-1.d0
               endif
               write(67,124) dfloat(ireduce)*amom(ix3d),
     +              dfloat(ireduce)*amom(iy3d),
     +              dfloat(ireduce)*amom(iz3d),
     +              c3d(ix3d,iy3d,iz3d),d3d(ix3d,iy3d,iz3d)	
            enddo
         enddo
      enddo
 124  format(f7.1,2x,f7.1,2x,f7.1,2x,f9.2,2x,f8.1)
      close(67)
      return
      end
